public class Student {

	private final String firstName;
	private final String lastName;
	private final long id;
	private final boolean graduated;
	private final Gender gender;
	private final Program program;

	public Student(String firstName, String lastName, long id,
			boolean graduated, Gender gender, Program program) {
		super();
		this.firstName = firstName;
		this.lastName = lastName;
		this.id = id;
		this.graduated = graduated;
		this.gender = gender;
		this.program = program;
	}
	
	@Override
	public int hashCode() {
	
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((firstName == null) ? 0 : firstName.hashCode());
		result = prime * result + ((gender == null) ? 0 : gender.hashCode());
		result = prime * result + (int) (id ^ (id >>> 32));
		result = prime * result
				+ ((lastName == null) ? 0 : lastName.hashCode());
		result = prime * result + ((program == null) ? 0 : program.hashCode());
		return result;
	}


	



	public String getFirstName() {
		return firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public long getId() {
		return id;
	}

	public boolean isGraduated() {
		return graduated;
	}

	public Gender getGender() {
		return gender;
	}

	public Program getProgram() {
		return program;
	}

	public Student graduate() {
		return new Student(firstName, lastName, id, true, gender, program);
	}

	
	



	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Student other = (Student) obj;
		if (firstName == null) {
			if (other.firstName != null)
				return false;
		} else if (!firstName.equals(other.firstName))
			return false;
		if (gender != other.gender)
			return false;
		if (id != other.id)
			return false;
		if (lastName == null) {
			if (other.lastName != null)
				return false;
		} else if (!lastName.equals(other.lastName))
			return false;
		if (program == null) {
			if (other.program != null)
				return false;
		} else if (!program.equals(other.program))
			return false;
		return true;
	}

}
