import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class StudentDB {

	Map<Long, Student> students = new HashMap<Long, Student>(10);

	Map<Student, List<Course>> enrolled = new HashMap<Student, List<Course>>(10);

	Student getStudent(long idNr) {
		return students.get(idNr);
	}

	public void addStudent(String firstName, String lastName, long id,
			boolean graduated, Gender gender, Program program) {
		students.put(id,new Student(firstName, lastName, id, graduated, gender, program));
	}

	public void graduate(long idNr) {
		Student student = students.get(idNr);
		students.put(student.getId(), student.graduate());
	}

	public void enroll(long idNr, Course course) {
		Student student = students.get(idNr);
		if (!enrolled.containsKey(student)) {
			enrolled.put(student, new LinkedList<Course>());
		}
		enrolled.get(student).add(course);
	}

	public Course[] getEnrolledCourses(long idNr) {
		Student student = students.get(idNr);
		if (!enrolled.containsKey(student)) {
			return new Course[] {};
		}
		return enrolled.get(student).toArray(new Course[] {});
	}

}
